SUBROUTINE cnum( i1, i2, ipas, car1, nc1, car2, nc2, code, ind, lc1, cval, lerr )

!***********************************************************************
!     - cnum -
!     retourne dans cval une valeur caractere
!     N.B. une fin de valeur caractere se repere par un caractere
!     sep1, sep2, par1, par2, ou les mots to ou by (du module creser)
!***********************************************************************
!
!     I1    - ENTREE. COLONNE DE DEBUT DE LA ZONE EXAMINEE    - ENTIER
!     I2    - ENTREE. COLONNE DE FIN   DE LA ZONE EXAMINEE    - ENTIER
!     IPAS  - ENTREE. NE PEUT ETRE QUE 1                      - ENTIER
!     CAR1  - ENTREE. 1ER  MOT "CIBLE"                        - CAR
!     NC1   - ENTREE. SA LONGUEUR                             - ENTIER
!     CAR2  - ENTREE. 2EME MOT "CIBLE"                        - CAR
!     NC2   - ENTREE. SA LONGUEUR                             - ENTIER
!     CODE  - ENTREE. SI CODE=.TRUE. ALORS LE MOT SUIVANT     - LOGIQUE
!                     CVAL DOIT EXISTER ET ETRE CAR1(:NC1)
!                     OU CAR2(:NC2)
!     IND   - SORTIE. LA COLONNE DU DERNIER CARACTERE DU MOT  - ENTIER
!                     (SEP1,SEP2,PAR1,PAR2,TO,BY) SUIVANT CVAL
!     LC1   - SORTIE. .TRUE. QUAND CODE=.TRUE. ET LE MOT      - LOGIQUE
!                     "CIBLE" EST(CAR1:NC1)
!     CVAL  - SORTIE. LA VALEUR TROUVEE (ERREUR SI AUCUNE)    - CAR
!     LERR  - SORTIE. .TRUE. SI UNE ERREUR EST DETECTEE       - LOGIQUE
!-----------------------------------------------------------------------

   USE carl
   USE flag_msg

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN)  :: i1, i2, ipas, nc1, nc2
   LOGICAL, INTENT(IN)  :: code
   CHARACTER(LEN=*), INTENT(IN) :: car1, car2
   INTEGER, INTENT(OUT) :: ind
   LOGICAL, INTENT(OUT) :: lc1, lerr
   CHARACTER(LEN=*), INTENT(OUT) :: cval

   !  Declarations locales
   !  --------------------

   INTEGER :: i, ii, jnd, kola, kolz

   INCLUDE 'illglp.'
   INCLUDE 'cnump.'

   !--------------------------------------------------------------------

   kola = max( 1, i1-17 )
   if ( ipas /= 1 .or. i2 < i1 ) then
      write(l6,*) mrker1
      write(l6,11) typer, car(kola:min(kola+64,ncar)), msgc0
      write(l6,*) mrker2
      lerr = .true.
      return
   end if

   lerr = .false.
   cval = ' '
   ind  = 0

   ! Boucle sur les caracteres de la zone
   ! ------------------------------------
   do i = i1, i2
      if ( .not. com(i) ) then
         if ( car(i:i) == sep1 .or. car(i:i) == sep2 .or.       &
              car(i:i) == par1 .or. car(i:i) == par2 ) then
            ind = i
            goto 10
         else
            ii = min( i+ncto-1, ncar )
            if ( car(i:ii) == to(:ncto) ) then
               ind = i
               goto 10
            else
               ii = min( i+ncby-1, ncar )
               if ( car(i:ii) == by(:ncby) ) then
                  ind = i
                  goto 10
               end if
            end if
         end if
      end if
   end do

   if ( code ) then
      write(l6,*) mrker1
      write(l6,11) typer, car(kola:min(kola+64,ncar))
      write(l6,*)  misdlm, car(i1:i2)
      write(l6,*) mrker2
      lerr = .true.
      return
   else
      ind = i2 + 1
   end if

10 continue
   if ( ind <= i1 ) then
      kola = max( i1-25, kola )
      kolz = min( i1+25, ncar )
      write(l6,*) mrker1
      write(l6,11) typer, car(kola:kolz), flag(:max(i1-kola,1))
      write(l6,*)  misnam, car(i1:i1)
      write(l6,*) mrker2
      lerr = .true.
      return
   end if
   cval = car(i1:ind-1)

   ! Test sur le mot attendu
   ! -----------------------
   lc1 = .false.
   if ( .not. code ) return
   jnd = ind
   ind = jnd + nc1 - 1
   if ( ind <= ncar ) then
      if ( car(jnd:ind) == car1(:nc1) ) then
         lc1 = .true.
         return
      end if
   end if
   ind = jnd + nc2 - 1
   if ( ind <= ncar ) then
      if ( car(jnd:ind) == car2(:nc2) ) return
   end if
   kola = max( jnd-25, kola )
   kolz = min( jnd+25, ncar )
   write(l6,*) mrker1
   write(l6,11) typer, car(kola:kolz), flag(:jnd-kola)
   write(l6,*)  illgl1, car(jnd:jnd), illgl2, car1(:nc1), illgl3, car2(:nc2)
   write(l6,*) mrker2
   lerr = .true.

   INCLUDE 'anaf11.'

END SUBROUTINE cnum
