LOGICAL FUNCTION lscalx( mot, longm, long, ideb, iend, ldef, icol, jcol, lerr )

!***********************************************************************
!     - lscalx -
!     retourne une valeur logique
!     ldef = valeur par defaut (entree)
!***********************************************************************

   USE carl

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN)  :: longm, long, ideb, iend
   LOGICAL, INTENT(IN)  :: ldef
   CHARACTER(LEN=*), INTENT(IN) :: mot
   INTEGER, INTENT(OUT) :: icol, jcol
   LOGICAL, INTENT(OUT) :: lerr

   !  Declarations locales
   !  --------------------

   INTEGER :: icl1, icl2, i1, j1, kol, kolz
   LOGICAL :: scansep
   CHARACTER(LEN=2) :: temp

   INCLUDE 'fkwdp.'
   INCLUDE 'notabbp.'
   INCLUDE 'lscalxp.'

   !--------------------------------------------------------------------

   lscalx = ldef
   lerr   = .false.
   icol   = 0
   jcol   = 0
   i1     = ideb
   scansep= .true.

   do      ! Boucle sur le mot cle
           ! ---------------------

      kol = index( car(i1:iend), mot(:long) ) + i1 - 1
      if ( kol < i1 ) return      ! Retour normal

      i1 = kol + long
      if ( com(kol) .or. com(kol+1) ) cycle
      icol = kol
      kolz = min( icol+64, ncar )
      ! Etude de l'abreviation eventuelle
      do j1 = long+1, longm
         jcol = icol - 1 + j1
         if ( car(jcol:jcol) == sep2 .and. .not. com(jcol) ) then
            scansep= .false.
            exit
         end if
         if ( car(jcol:jcol) /= mot(j1:j1) ) then
            write(l6,*) mrker1
            write(l6,11) typer, car(icol:kolz)
            write(l6,*)  car(icol:jcol), notabb, mot(:longm)
            write(l6,*) mrker2
            lerr = .true.
            return
         end if
      end do
      if ( scansep ) then
         jcol = icol + longm
         if ( car(jcol:jcol) /= sep2 .or. com(jcol) ) then
            write(l6,*) mrker1
            write(l6,11)  typer, car(icol:kolz)
            write(l6,111) sep2
            write(l6,*)   car(icol:jcol-1)
            write(l6,*)   fkwd, mot(:longm)
            write(l6,*) mrker2
            lerr = .true.
            return
         end if
      end if

      ! Analyse de la valeur affectee au mot cle
      lscalx = .true.
      icl2   = max( 1, icol-2 )
      icl1   = max( 2, icol-1 )
      temp   = car(icl2:icl1)
      call cvuct( temp )
      if ( icol > 2 .and. temp == 'NO' .and. .not. (com(icl2) .or. com(icl1)) ) then
         lscalx = .false.
         icol   = icl2
      end if

      ! Effacement de la zone analysee
      car(icol:jcol-1) = ' '

      ! D'autres occurrences du mot cle ? i1=col de debut d'exploration
   end do

   INCLUDE 'anaf11.'
   INCLUDE 'lscalxf.'

END FUNCTION lscalx
