SUBROUTINE positm( mot, longm, long, ideb, iend, icol, icol1, icol2, lerr )

!***********************************************************************
!     - positm -
!     donne la position dans car:
!     d'un mot cle, du signe "=" ou par1 le suivant, de la fin de
!     phrase (sep2) associee
!     N.B. toutes les positions retournees sont des positions absolues
!     dans car(1:ncar) et non dans car(ideb:iend)
!     un mot cle doit etre constitue d'au moins 2 caracteres
!***********************************************************************
!
!     MOT   - ENTREE. LE MOT CLE                              - CAR
!     LONGM - ENTREE. SA LONGUEUR COMPLETE                    - ENTIER
!     LONG  - ENTREE. SA LONGUEUR EN ABREVIATION MAXIMUM      - ENTIER
!     IDEB  - ENTREE. COL. DE DEBUT D'EXPLORATION             - ENTIER
!     IEND  - ENTREE. COL. DE FIN        "                    - ENTIER
!     ICOL  - SORTIE. COL. DU DEBUT DU MOT CLE                - ENTIER
!                     (0 SI NON TROUVE)
!     ICOL1 - SORTIE. COL. DU CARACTERE "=" OU PAR1 DEVANT    - ENTIER
!                     SUIVRE MOT
!     ICOL2 - SORTIE. COL. DE LA FIN DE PHRASE (SEP2)         - ENTIER
!     LERR  - SORTIE. .TRUE. SI UNE ERREUR EST DETECTEE       - LOGIQUE
!-----------------------------------------------------------------------

   USE carl
   USE flag_msg

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN) :: longm, long, ideb, iend
   CHARACTER(LEN=*), INTENT(IN) :: mot
   INTEGER, INTENT(OUT) :: icol, icol1, icol2
   LOGICAL, INTENT(OUT) :: lerr


   !  Declarations locales
   !  --------------------

   INTEGER :: i1, kol, kola, kolz
   LOGICAL :: scan

   INCLUDE 'fkwdp.'
   INCLUDE 'notabbp.'
   INCLUDE 'notfolp.'
   INCLUDE 'positmp.'

   !--------------------------------------------------------------------

   icol  = 0
   icol1 = 0
   icol2 = 0
   lerr  = .false.

   ! Positionnement sur le mot cle
   ! -----------------------------
   i1 = ideb
   do
      if ( i1 > iend ) return
      kol = index( car(i1:iend), mot(:long) ) + i1 - 1
      if ( kol < i1 ) return
      i1  = kol + long
      if ( .not. (com(kol) .or. com(kol+1)) ) exit
   end do
   icol = kol

   kolz = min( icol+64, ncar )

   ! Etude de l'abreviation eventuelle
   ! ---------------------------------
   scan = .true.
   do i1 = long+1, longm
      icol1 = icol - 1 + i1
      if ( car(icol1:icol1) == '=' .or. car(icol1:icol1) == par1 ) then
         scan = .false.
         exit
      end if
      if ( car(icol1:icol1) /= mot(i1:i1) ) then
         write(l6,*) mrker1
         write(l6,11) typer, car(icol:kolz)
         write(l6,*)  car(icol:icol1), notabb, mot(:longm)
         write(l6,*) mrker2
         lerr = .true.
         return
      end if
   end do
   if ( scan ) then
      icol1 = icol + longm
      if ( com(icol1) .or. (car(icol1:icol1) /= '=' .and. car(icol1:icol1) /= par1) ) then
         kola = max( icol1-25, icol )
         kolz = min( icol1+25, ncar )
         write(l6,*) mrker1
         write(l6,11) typer, car(kola:kolz), flag(:icol1-kola)
         write(l6,*)  car(icol:icol1-1), notfol, '=', fol2, par1
         write(l6,*) mrker2
         lerr = .true.
         return
      end if
   end if

   ! Recherche de la fin de la phrase (sep2)
   ! ---------------------------------------
   kol = icol1 + 1
   do
      if ( kol > iend ) then
         write(l6,*) mrker1
         write(l6,11) typer, car(icol:kolz)
         write(l6,22) sep2
         write(l6,*)  fkwd, mot
         write(l6,*) mrker2
         lerr = .true.
         return
      end if
      icol2 = index( car(kol:iend), sep2) + kol - 1
      if ( icol2 < kol ) then
         write(l6,*) mrker1
         write(l6,11) typer, car(icol:kolz)
         write(l6,22) sep2
         write(l6,*)  fkwd, mot
         write(l6,*) mrker2
         lerr = .true.
         return
      end if
      if ( .not. com(icol2) ) exit
      kol = icol2 + 1   ! sep2 etant en "commentaire" on recommence
   end do

   INCLUDE 'anaf11.'
   INCLUDE 'anaf22.'

END SUBROUTINE positm
