INTEGER FUNCTION indxt( i, j )

!***********************************************************************
!     - indxt -
!     returns the index corresponding to cell (I,J) for a matrix stored
!     in packed triangular form
!***********************************************************************
!
!     I     - INPUT . Row index                               - INTEGER
!     J     - INPUT . Column index                            - INTEGER
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        NONE
!     External functions called:
!        NONE
!     Fortran  functions called:
!        NONE
!
!-----------------------------------------------------------------------

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN) :: i, j

   !--------------------------------------------------------------------

   if ( i >= j ) then
      indxt = i*(i-1)/2 + j
   else
      indxt = j*(j-1)/2 + i
   end if

END FUNCTION indxt
