INTEGER FUNCTION jchar( c )

!***********************************************************************
!     - jchar -
!     returns the position of a character in the ASCII collating
!     sequence, just like the intrinsic function IACHAR, but in the
!     case of a lower case letter on input, it  returns the position
!     of the corresponding upper case letter
!***********************************************************************
!
!     c     - INPUT . Character                               - CHAR
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        NONE
!     External functions called:
!        NONE
!     Fortran  functions called:
!        IACHAR
!
!-----------------------------------------------------------------------

   IMPLICIT NONE

   !  Arguments
   !  ---------

   CHARACTER(LEN=1), INTENT(IN) :: c

   !  Local declarations
   !  ------------------

   INTEGER, PARAMETER :: konv=-32      ! iachar('A') - iachar('a')
   INTEGER, PARAMETER :: ia=97, iz=122 ! ia=iachar('a'); iz=iachar('z')

   !--------------------------------------------------------------------

   jchar = iachar(c)
   IF ( jchar >= ia .AND. jchar <= iz ) jchar = jchar + konv

END FUNCTION jchar
