      SUBROUTINE MABS( A , B , S , M , N )
!***********************************************************************
!     - MABS -
!     multiplies general matrix A by general matrix B to form symmetric
!     matrix S (stored in triangular form)
!***********************************************************************
!
!     A     - INPUT . General matrix (columnwise)             - REAL*8
!     B     - INPUT . General matrix (columnwise)             - REAL*8
!     S     - OUTPUT. Resultant symmetric matrix              - REAL*8
!                     (in triangular form)
!     M     - INPUT . Number of rows and columns in S,        - INTEGER
!                     of rows in A, of columns in B
!     N     - INPUT . Number of columns in A, of rows in B    - INTEGER
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        NONE
!     External functions called:
!        NONE
!     Fortran  functions called:
!        NONE
!
!-----------------------------------------------------------------------
!
!
      INTEGER           M     , N
      DOUBLE PRECISION  A (M*N) , B(N*M) , S (M*(M+1)/2)
!
!        LOCAL DECLARATIONS
!        ------------------
      DOUBLE PRECISION  SUM   , ZERO
!
      PARAMETER (ZERO=0.0D0)
!
!     ------------------------------------------------------------------
!
!
      IS = 0
!
      DO 30 I = 1, M
         JJ = -N
!
         DO 20 J = 1, I
            IK  = I  - M
            JJ  = JJ + N
            IS  = IS + 1
            SUM = ZERO
!
            DO 10 KJ = JJ+1, JJ+N
               IK  = IK + M
               SUM = SUM  +  A(IK) * B(KJ)
   10       CONTINUE
!
            S(IS) = SUM
   20    CONTINUE
!
   30 CONTINUE
!
      END
