SUBROUTINE mtabc( a, b, c, l, m, n )

!***********************************************************************
!     - mtabc -
!     multiplies the transpose of general matrix A by general matrix B
!     to form resultant general matrix C
!***********************************************************************
!
!     A     - INPUT . General matrix                          - REAL*8
!     B     - INPUT . General matrix                          - REAL*8
!     C     - OUTPUT. Resultant general matrix                - REAL*8
!     L     - INPUT . Number of rows in A and B               - INTEGER
!     M     - INPUT . Number of columns in A and rows in C    - INTEGER
!     N     - INPUT . Number of columns in C                  - INTEGER
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        NONE
!     External functions called:
!        NONE
!     Fortran  functions called:
!        MATMUL  SUM  TRANSPOSE
!
!-----------------------------------------------------------------------

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN) :: l, m, n
   REAL(KIND=8), INTENT(IN) :: a(l,m), b(l,n)
   REAL(KIND=8), INTENT(OUT) :: c(m,n)

   !--------------------------------------------------------------------

   c = matmul( transpose(a), b )

END SUBROUTINE mtabc
