      SUBROUTINE MTABS( A , B , S , M , N )
!***********************************************************************
!     - MTABS -
!     multiplies transpose of general matrix A by general matrix B
!     to form symmetric matrix S (stored in triangular form)
!***********************************************************************
!
!     A     - INPUT . General matrix (columnwise)             - REAL*8
!     B     - INPUT . General matrix (columnwise)             - REAL*8
!     S     - OUTPUT. Resultant symmetric matrix              - REAL*8
!                     (in triangular form)
!     M     - INPUT . Number of rows in A and B               - INTEGER
!     N     - INPUT . Number of columns in A and B,           - INTEGER
!                     of rows and columns in S
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        NONE
!     External functions called:
!        NONE
!     Fortran  functions called:
!        NONE
!
!-----------------------------------------------------------------------
!
!
      INTEGER           M     , N
      DOUBLE PRECISION  A (M*N) , B(M*N) , S (N*(N+1)/2)
!
!        LOCAL DECLARATIONS
!        ------------------
      DOUBLE PRECISION  SUM   , ZERO
!
      PARAMETER (ZERO=0.0D0)
!
!     ------------------------------------------------------------------
!
!
      IS = 0
      KI = -M
!
      DO 30 I = 1, N
         KI  = KI + M
         KJ = -M
!
         DO 20 J = 1, I
            KJ  = KJ + M
            IS  = IS + 1
            SUM = ZERO
!
            DO 10 K = 1, M
               SUM = SUM  +  A(K+KI) * B(K+KJ)
   10       CONTINUE
!
            S(IS) = SUM
   20    CONTINUE
!
   30 CONTINUE
!
      END
