REAL(KIND=8) FUNCTION pythag( a, b )

!     -- A SUBROUTINE FROM EISPACK PACKAGE --

!     Finds sqrt(a**2+b**2) without overflow or destructive underflow

   real(kind=8), intent(in) :: a, b
   real(kind=8), parameter :: zero=0.0_8, one=1.0_8, four=4.0_8
   real(kind=8) :: p, r, s, t, u
!     Fortran functions: abs, max, min

   p = max(abs(a),abs(b))
   if (p > zero ) then
      r = (min(abs(a),abs(b))/p)**2
      do
         t = four + r
         if ( t == four ) exit
         s = r/t
         u = one + s + s
         p = u*p
         r = (s/u)**2 * r
      end do
   end if
   pythag = p

END FUNCTION pythag
