SUBROUTINE inumber( str, last, n )

!***********************************************************************
!     - inumber -
!     returns a (positive) integer value given a corresponding character
!     string
!***********************************************************************
!
!     str   - INPUT . Character string begining with a digit  - CHAR
!     last  - OUTPUT. Position in str of the last digit of    - INTEGER
!                     the integer number returned
!     n     - OUTPUT. Integer number                          - INTEGER
!
!-----------------------------------------------------------------------
!
!     Subroutines called :
!        NONE
!     External functions called :
!        NONE
!     Fortran  functions called :
!        IACHAR  LEN_TRIM
!
!-----------------------------------------------------------------------

   IMPLICIT NONE

   !  Arguments
   !  ---------

   CHARACTER(LEN=*), INTENT(IN) :: str
   INTEGER, INTENT(OUT) :: last, n

   !  Local declarations
   !  ------------------

   INTEGER, PARAMETER :: ncodc=255 ! Maximum iachar rank
   INTEGER, PARAMETER :: izero=iachar("0")
   INTEGER :: i, j, k
   LOGICAL :: ldigit(0:ncodc)=(/ (.FALSE.,i=0,izero-1),(.TRUE.,i=izero,izero+9),(.FALSE.,i=izero+10,ncodc) /)

   !--------------------------------------------------------------------

   n = 0
   k = len_trim(str)
   do i = 1, k
      j = iachar( str(i:i) )
      if ( ldigit(j) ) then             ! Digit found
         n = n*10 + (j-izero)
        else                            ! Not a digit: the end
         last = i - 1
         return
      end if
   end do
   last = k

END SUBROUTINE inumber
