SUBROUTINE chkunt( lerr, iout, iunt,                                   &
                   u1, u2, u3, u4, u5, u6, u7, u8, u9, u10, u11, u12 )
!***********************************************************************
!     - chkunt -
!     checks whether a unit number is already allocated
!***********************************************************************
!
!     LERR  - OUTPUT. .true. if IUNT is already allocated     - LOGICAL
!     IOUT  - INPUT . Unit number for message printing        - INTEGER
!     IUNT  - INPUT . Unit number to be checked               - INTEGER
!     U1 to - INPUT . Unit numbers compared to IUNT: those    - INTEGER
!     U12             already allocated (target unit numbers)
!
!     --------------------------------------------------------
!     Module elements modified:
!     gmpint : lines
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        CHKPG
!     External functions called:
!        NONE
!     Fortran  functions called:
!        PRESENT
!
!-----------------------------------------------------------------------

   USE gmpchr
   USE gmpint

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN) :: iout, iunt
   INTEGER, INTENT(IN), OPTIONAL :: u1, u2, u3, u4, u5, u6, u7, u8, u9, u10, u11, u12
   LOGICAL, INTENT(OUT) :: lerr

   !  Local declarations
   !  ------------------

   LOGICAL :: newp

   !--------------------------------------------------------------------

   lerr = .false.
   if ( .not. present(u1) ) return
   if ( iunt == u1 ) goto 10

   if ( .not. present(u2) ) return
   if ( iunt == u2 ) goto 10

   if ( .not. present(u3) ) return
   if ( iunt == u3 ) goto 10

   if ( .not. present(u4) ) return
   if ( iunt == u4 ) goto 10

   if ( .not. present(u5) ) return
   if ( iunt == u5 ) goto 10

   if ( .not. present(u6) ) return
   if ( iunt == u6 ) goto 10

   if ( .not. present(u7) ) return
   if ( iunt == u7 ) goto 10

   if ( .not. present(u8) ) return
   if ( iunt == u8 ) goto 10

   if ( .not. present(u9) ) return
   if ( iunt == u9 ) goto 10

   if ( .not. present(u10) ) return
   if ( iunt == u10 ) goto 10

   if ( .not. present(u11) ) return
   if ( iunt == u11 ) goto 10

   if ( .not. present(u12) ) return
   if ( iunt == u12 ) goto 10

   return

   10 continue      ! Error: unit number already allocated
      lerr = .true.
      call chkpg( 2, .false., newp )
      write(iout,11) iunt
      lines = lines + 2
      write(lgu,*) ermrk1
      write(lgu,11) iunt
      write(lgu,*) ermrk2

   INCLUDE 'chkuntf.'

END SUBROUTINE chkunt
