SUBROUTINE datrun( arg )

!***********************************************************************
!     - datrun -
!     returns current date as a character string in the first 8
!     characters of arg (of length >= 8), in the form: dd/mm/yy
!     (dd: day, mm: month, yy: year)
!***********************************************************************
!
!     Subroutines called:
!        NONE
!     External functions called:
!        NONE
!     Fortran  procedures called:
!        DATE_AND_TIME  LEN
!
!-----------------------------------------------------------------------

   IMPLICIT NONE

   !   Arguments
   !   ---------

   CHARACTER(LEN=*), INTENT(INOUT) :: arg

   !   Local declarations
   !   ------------------

   CHARACTER(LEN=8)  :: date
   CHARACTER(LEN=10) :: time
   CHARACTER(LEN=5)  :: zone
   INTEGER, DIMENSION(8) :: nv

   !--------------------------------------------------------------------

   IF ( LEN(arg) >= 8 ) THEN
      CALL DATE_AND_TIME( date, time, zone, nv )
      arg = date(7:8) // "/" // date(5:6) // "/" // date(3:4)
   END IF

END SUBROUTINE datrun
