SUBROUTINE filerr( typer, unit, filnam, frmtd, accss, stat )

!***********************************************************************
!     - filerr -
!     prints a message when an error occurred during file operation
!***********************************************************************
!
!     TYPER - INPUT . Type of action in error                 - CHAR
!                     (open, most commonly)
!     UNIT  - INPUT . Unit number                             - INTEGER
!     FILNAM- INPUT . File name                               - CHAR
!     FRMTD - INPUT . Form specifier                          - CHAR
!     ACCSS - INPUT . Access type specifier                   - CHAR
!     STAT  - INPUT . Status specifier                        - CHAR
!
!     --------------------------------------------------------
!     Module elements modified:
!     gmpint : lines
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        CHKPG
!     External functions called:
!        NONE
!     Fortran  functions called:
!        NONE
!
!-----------------------------------------------------------------------

   USE gmpchr
   USE gmpint

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN) :: unit
   CHARACTER(LEN=*), INTENT(IN) :: typer, filnam, frmtd, accss, stat

   !  Local declarations
   !  ------------------

   LOGICAL :: newp
   INCLUDE 'filerrp.'

   !--------------------------------------------------------------------

   call chkpg( 6, .false., newp )
   write(lgu,*) ermrk1
   write(lgu,111) typer, unit
   write(lgu,*)   name, filnam
   write(lgu,222) frmtd, accss, stat
   lines = lines + 5
   if ( typer(1:3) == opn3 .and. stat(1:7) /= 'SCRATCH' ) then
      write(lgu,333)
      lines = lines + 1
   endif
   write(lgu,*) ermrk2

   INCLUDE 'filerrf.'

END SUBROUTINE filerr
