SUBROUTINE filter( num, n, iflag )

!***********************************************************************
!     - filter -
!     filters a list of integers: drops any integer equal to a flag
!     code and cancels replications if any
!***********************************************************************
!
!     NUM   - INPUT . Array of integers                       - INTEGER
!             OUTPUT. Updated array (without replications,
!                     i.e. identical elements, nor elements
!                     equal to IFLAG)
!     N     - INPUT . Number of elements in NUM               - INTEGER
!             OUTPUT. Updated value
!     IFLAG - INPUT . Any number in the array which is equal  - INTEGER
!                     to this one is dropped from the array
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        NONE
!     External functions called:
!        NONE
!     Fortran  functions called:
!        NONE
!
!-----------------------------------------------------------------------

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN) :: iflag
   INTEGER, INTENT(INOUT) :: n
   INTEGER, DIMENSION(n), INTENT(INOUT) :: num

   !  Local declarations
   !  ------------------

   INTEGER :: i, j, k

   !--------------------------------------------------------------------

   k = 0
   out_loop: do i = 1, n
      if ( num(i) == iflag ) cycle out_loop
      do j = 1, k
         if ( num(i) == num(j) ) cycle out_loop
      end do
      k = k + 1
      num(k) = num(i)
   end do out_loop
   n = k

END SUBROUTINE filter
