SUBROUTINE ftriv( n, x, y )

!***********************************************************************
!     - ftriv -
!     sorts x in descending order and reorders y accordingly
!***********************************************************************
!
!     N     - INPUT . Length of X and Y                       - INTEGER
!     X     - INPUT . Vector to be sorted                     - INTEGER
!             OUTPUT. Sorted vector
!     Y     - INPUT . Vector to be reordered accordingly to X - INTEGER
!             OUTPUT. Sorted vector
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        NONE
!     External functions called:
!        NONE
!     Fortran  functions called:
!        NONE
!
!-----------------------------------------------------------------------

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN) :: n
   INTEGER, DIMENSION(n), INTENT(INOUT) :: x, y

   !  Local declarations
   !  ------------------

   INTEGER :: j, jml, k, l, xj, yj

   !--------------------------------------------------------------------

   do j = 2, n
      xj = x(j)
      do k= 1, j-1
         if ( xj > x(k) ) then
            yj = y(j)
            do l = 1, j-k
               jml = j - l
               x(jml+1) = x(jml)
               y(jml+1) = y(jml)
            end do
            x(k) = xj
            y(k) = yj
            exit
         end if
      end do
   end do

END SUBROUTINE ftriv
