SUBROUTINE tcpu( iout, prt, txt )

!***********************************************************************
!     - tcpu -
!     gets and prints time elapsed since previous call
!     (calls Fortran subroutine date_and_time)
!     iout is output unit number
!     if prt=.true.  time and character string txt are printed
!     if prt=.false. nothing is printed
!***********************************************************************

   IMPLICIT NONE

   !   Arguments
   !   ---------

   INTEGER, INTENT(IN) :: iout
   LOGICAL, INTENT(IN) :: prt
   CHARACTER(LEN=*), INTENT(IN) :: txt

   !   Local declarations
   !   ------------------

   CHARACTER(LEN=8)  :: date
   CHARACTER(LEN=10) :: time
   CHARACTER(LEN=5)  :: zone
   INTEGER, DIMENSION(8) :: nv
   REAL(KIND=8), SAVE :: prev_time=0.0_8
   REAL(KIND=8)       :: curr_time
   INTEGER, SAVE :: prev_day=0
   INTEGER       :: curr_day

   !--------------------------------------------------------------------

   call date_and_time( date, time, zone, nv )
   curr_time = nv(5)*3600.0_8 + nv(6)*60.0_8 + nv(7) + nv(8)*1.0e-3_8
   curr_day = nv(3)
   if ( prev_day > 0 .and. curr_day > prev_day ) prev_time = prev_time - 86400.0_8
   if ( prt ) write(iout,"(1x,a,f10.3,' sec.')") txt, curr_time-prev_time
   prev_time = curr_time
   prev_day = curr_day

END SUBROUTINE tcpu
