SUBROUTINE pac999( u1, u2, u3 )

!***********************************************************************
!     - pac999 -
!     deallocate arrays and close files used in the specific section
!     of the program
!***********************************************************************
!
!     u1    - INPUT . Additional unit number (optional)       - INTEGER
!     u2    - INPUT . Additional unit number (optional)       - INTEGER
!     u3    - INPUT . Additional unit number (optional)       - INTEGER
!
!-----------------------------------------------------------------------

   USE memst2
   USE memstb
   USE pacint

   IMPLICIT NONE

   !  Arguments
   !  ---------

   INTEGER, INTENT(IN), OPTIONAL :: u1, u2, u3

   !--------------------------------------------------------------------

      ! Deallocate arrays if not done yet
      ! ---------------------------------

   IF ( ALLOCATED(at  ) ) DEALLOCATE(at  )
   IF ( ALLOCATED(hyp0) ) DEALLOCATE(hyp0)
   IF ( ALLOCATED(xlim) ) DEALLOCATE(xlim)
   IF ( ALLOCATED(xbar) ) DEALLOCATE(xbar)
   IF ( ALLOCATED(ag  ) ) DEALLOCATE(ag  )
   IF ( ALLOCATED(vec1) ) DEALLOCATE(vec1)
   IF ( ALLOCATED(v   ) ) DEALLOCATE(v   )
   IF ( ALLOCATED(w   ) ) DEALLOCATE(w   )
   IF ( ALLOCATED(udpw) ) DEALLOCATE(udpw)
   IF ( ALLOCATED(ybar) ) DEALLOCATE(ybar)
   IF ( ALLOCATED(ys2 ) ) DEALLOCATE(ys2 )
   IF ( ALLOCATED(eff ) ) DEALLOCATE(eff )
   IF ( ALLOCATED(ene ) ) DEALLOCATE(ene )
   IF ( ALLOCATED(qne ) ) DEALLOCATE(qne )
   IF ( ALLOCATED(yqg ) ) DEALLOCATE(yqg )
   IF ( ALLOCATED(usev) ) DEALLOCATE(usev)
   IF ( ALLOCATED(tstr) ) DEALLOCATE(tstr)
   IF ( ALLOCATED(gmod) ) DEALLOCATE(gmod)
   IF ( ALLOCATED(tmod) ) DEALLOCATE(tmod)
   IF ( ALLOCATED(ctab) ) DEALLOCATE(ctab)
   IF ( ALLOCATED(gcod) ) DEALLOCATE(gcod)
   IF ( ALLOCATED(gmax) ) DEALLOCATE(gmax)
   IF ( ALLOCATED(gnum) ) DEALLOCATE(gnum)
   IF ( ALLOCATED(gorg) ) DEALLOCATE(gorg)
   IF ( ALLOCATED(gapp) ) DEALLOCATE(gapp)
   IF ( ALLOCATED(gsup) ) DEALLOCATE(gsup)
   IF ( ALLOCATED(gstr) ) DEALLOCATE(gstr)
   IF ( ALLOCATED(supg) ) DEALLOCATE(supg)
   IF ( ALLOCATED(lgtx) ) DEALLOCATE(lgtx)
   IF ( ALLOCATED(lres) ) DEALLOCATE(lres)

      ! Close files
      ! -----------

   CLOSE(junit1)
   CLOSE(junit2)
   CLOSE(junit3)
   IF ( ibayes > 0 ) CLOSE(ibayes)
   IF ( ideriv > 0 ) CLOSE(ideriv)
   IF ( present(u1) ) CLOSE(u1)
   IF ( present(u2) ) CLOSE(u2)
   IF ( present(u3) ) CLOSE(u3)

END SUBROUTINE pac999
