SUBROUTINE pacin1( lerr )

!***********************************************************************
!     - pacin1 -
!     performs INitializations in modules specific to program PAC
!     (initializations made only once, when program starts)
!***********************************************************************
!
!     LERR  - OUTPUT. .true. if an error is detected          - LOGICAL
!
!-----------------------------------------------------------------------
!
!     Subroutines called:
!        FILOPN
!     External functions called:
!        NONE
!     Fortran  functions called:
!        IACHAR
!
!-----------------------------------------------------------------------

   USE gmpint
   USE pacchr
   USE pacdtr
   USE pacint
   USE paclet
   USE paclgl
   USE pacrnk

   IMPLICIT NONE

   !  Arguments
   !  ---------

   LOGICAL, INTENT(OUT) :: lerr

   !  Local declarations
   !  ------------------

   INCLUDE 'pacin1p.'

   !--------------------------------------------------------------------

   lerr = .false.

      ! pacint

   gpond  = 1      ! Default weighting options for derivation
   tpond  = 2      ! (see also cmpgwo and cmptwo in pacchr below)
   ideriv = -999   ! Unit number for "derived protocol" save-file
   ibayes = -999   ! Unit number for "Bayes" save-file
   nbayes = 0      ! Bayesian distribution numbering

      ! paclgl

   lbayes = .false.
   lderiv = .false.

      ! Open scratch units in gmpint always needed
      ! (more scratch units will be opened later on, as needed)
   call filopn( 0, iu2, ' ', 'SCRATCH', 'UNFORMATTED', .false., lerr )
   if ( lerr ) return
   call filopn( 0, iu3, ' ', 'SCRATCH', 'UNFORMATTED', .false., lerr )
   if ( lerr ) return
   call filopn( 0, iu4, ' ', 'SCRATCH', 'UNFORMATTED', .false., lerr )
   if ( lerr ) return

      ! pacdtr

!! delta = 1.0e-4_8    ! PAC 1.50 setting
   delta = 1.0e-10_8   ! PAC 2.00 setting
!! betal = 1.0e+3_8    ! PAC 1.50 setting
!! betal = 1.0e+6_8    ! PAC 2.00 setting      obsolete
   acste = 1.0_8
   bcste = 0.0_8
!! maxit = 2000        ! PAC 1.50 setting
   maxit = 4000        ! PAC 2.00 setting
   iappr = 0

      ! pacchr   and   pacrnk

   sycond = '/'
   syinte = '.'
   syprod = '*'
   sycomp = ','
   syand  = '&'
   syor   = '_'
   syplus = '+'
   synest = '('
   noform = '#'
   krnk0  = iachar( '0' )
   krnka  = iachar( 'A' )
   krnkz  = iachar( 'Z' )
   kblan  = iachar( ' ' )
   kcond  = iachar( sycond )
   kinte  = iachar( syinte )
   kprod  = iachar( syprod )
   kcomp  = iachar( sycomp )
   kand   = iachar( syand )
   kor    = iachar( syor )
   kplus  = iachar( syplus )
   knest  = iachar( synest )
   knes2  = 0

      ! pacchr

   cmpgwo = typwg1
   cmptwo = typwg2
   bayfil = '        '
   baycod = '        '
      ! Default comparison formulas are none symbol
   cmpfor(1:maxnf) = noform

      ! paclet

   ifac(0:127) = 0

END SUBROUTINE pacin1
